package com.wor.appvideo;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.GridView;
import android.widget.ImageView;
import android.content.DialogInterface.OnKeyListener;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.SimpleAdapter;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.HashMap;

import cn.kaer.mobilevideo.core.KaerController;
import cn.kaer.mobilevideo.service.LoginListener;
import cn.kaer.mobilevideo.service.VideoListener;
import org.apache.cordova.CordovaActivity;
import com.wor.citycenter.R;

public class PlayActivity extends CordovaActivity {
    public static final int UP_ID = 0;
    public static final int DOWN_ID = 1;
    public static final int LEFT_ID = 2;
    public static final int RIGHT_ID = 3;
    public static final int ZOOMIN_ID = 4;
    public static final int ZOOMOUT_ID = 5;
    public static final int LISTEN_ID = 6;
    public static final int TALK_ID = 7;

    private KaerController controller = KaerController.getInstance();
    private LoginListener loginListener;
    private Handler handler;
    int nodeID;
    String videoType;
    byte channel;
    boolean isChild = false;
    private ProgressDialog progressDialog;

    Dialog menuDialog;
    GridView menuGrid;
    View menuView;

    boolean isListen = false;
    boolean isTalk = false;

    int[] menu_image_array11 = { R.drawable.up, R.drawable.down,
            R.drawable.left, R.drawable.right, R.drawable.viewb,
            R.drawable.views, R.drawable.listenup, R.drawable.talkup };
    int[] menu_image_array21 = { R.drawable.up, R.drawable.down,
            R.drawable.left, R.drawable.right, R.drawable.viewb,
            R.drawable.views, R.drawable.listendown, R.drawable.talkup };
    int[] menu_image_array12 = { R.drawable.up, R.drawable.down,
            R.drawable.left, R.drawable.right, R.drawable.viewb,
            R.drawable.views, R.drawable.listenup, R.drawable.talkdown };
    int[] menu_image_array22 = { R.drawable.up, R.drawable.down,
            R.drawable.left, R.drawable.right, R.drawable.viewb,
            R.drawable.views, R.drawable.listendown, R.drawable.talkdown };
    String[] menu_name_array = { "上", "下", "左", "右", "变倍大", "变倍小", "监听", "对讲" };

    /**
     * 更新选项菜单条目的状态
     *
     * @param isTalk
     *            talking
     * @param isListen
     *            listening
     */
    private void SetGridViewBg(boolean isTalk, boolean isListen) {
        if (isTalk && isListen) {
            menuGrid.setAdapter(getMenuAdapter(menu_name_array,
                    menu_image_array22));
        } else if (isTalk && !isListen) {
            menuGrid.setAdapter(getMenuAdapter(menu_name_array,
                    menu_image_array12));
        } else if (!isTalk && isListen) {
            menuGrid.setAdapter(getMenuAdapter(menu_name_array,
                    menu_image_array21));
        } else {
            menuGrid.setAdapter(getMenuAdapter(menu_name_array,
                    menu_image_array11));
        }
    }

    private SimpleAdapter getMenuAdapter(String[] menuNameArray, int[] imageResourceArray) {
        ArrayList<HashMap<String, Object>> data = new ArrayList<HashMap<String, Object>>();
        for (int i = 0; i < menuNameArray.length; i++) {
            HashMap<String, Object> map = new HashMap<String, Object>();
            map.put("itemImage", imageResourceArray[i]);
            map.put("itemText", menuNameArray[i]);
            data.add(map);
        }
        return new SimpleAdapter(this, data, R.layout.item_menu, new String[] {"itemImage", "itemText" }, new int[] { R.id.item_image, R.id.item_text });
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Intent intent = getIntent();
        nodeID = Integer.parseInt(intent.getStringExtra("nodeID"));
        videoType = intent.getStringExtra("videoType");
        String inforID = intent.getStringExtra("inforID");
        channel = (byte)Integer.parseInt(inforID);
        Log.v("worlcy", "play==="+nodeID+","+inforID+","+videoType+","+ channel);

        progressDialog = new ProgressDialog(PlayActivity.this);
        progressDialog.setTitle("状态");
        progressDialog.setMessage("正请求视频");
        progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        progressDialog.setIndeterminate(false);
        progressDialog.setCancelable(false);
        progressDialog.show();

        handler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                switch (msg.what) {
                    case 1:
                        controller.stopListen(nodeID, channel,isChild);
                        controller.stopRealTimeVideo();
                        controller.logout();
                        Log.v("worlcy", "出错1");
                        break;
                    case 2:
                        if (!Thread.currentThread().isInterrupted()) {
                            if (progressDialog.isShowing())
                                progressDialog.dismiss();
                        }
                        break;
                    case 3:
                        if (!Thread.currentThread().isInterrupted()) {
                            if (progressDialog.isShowing())
                                progressDialog.dismiss();
                            Log.v("worlcy", "请求视频失败，请重试！");
                        }
                        break;
                    case 4:
                        if (!Thread.currentThread().isInterrupted()) {
                            controller.stopListen(nodeID, channel, isChild);
                            Log.v("worlcy", "视频异常中断，请重试！");
                        }
                        break;
                    case 5:
                        if (!Thread.currentThread().isInterrupted()) {
                            controller.stopListen(nodeID, channel, isChild);
                            Log.v("worlcy", "视频格式不支持，请重试！");
                        }
                        break;
                    default:
                        break;
                }

                super.handleMessage(msg);
            }
        };

        VideoListener videoListener = new VideoListener() {
            @Override
            public void onVideoOK() {
                Message msg = new Message();
                msg.what = 2;
                handler.sendMessage(msg);
            }

            @Override
            public void onVideoFail() {
                Message msg = new Message();
                msg.what = 3;
                handler.sendMessage(msg);
            }

            @Override
            public void onVideoLost() {
                Message msg = new Message();
                msg.what = 4;
                handler.sendMessage(msg);
            }

            @Override
            public void onVideoTypeUnsupport() {
                Message msg = new Message();
                msg.what = 5;
                handler.sendMessage(msg);
            }
        };

        loginListener = new LoginListener() {
            @Override
            public void onLoginStatus(int status) {
                if (!Thread.currentThread().isInterrupted()) {
                    if (status == KaerController.LOGIN_LOST) {
                        Message msg = new Message();
                        msg.what = 1;
                        handler.sendMessage(msg);
                    }
                }
            }
        };

        controller.registerLoginListener(loginListener);

        WeakReference<Context> weakCtx = new WeakReference<Context>(this);
        ImageView videoView = controller.startRealTimeVideo(nodeID, channel, videoType, weakCtx.get(), false,videoListener);
        if (videoView != null) {
            setContentView(videoView);
        } else {
            Log.v("worlcy", "view == null");
        }
        //setContentView(R.layout.activity_play);


        menuView = View.inflate(this, R.layout.gridview_menu, null);
        menuDialog = new Dialog(this, R.style.dialog);
        WindowManager.LayoutParams lp = menuDialog.getWindow().getAttributes();
        lp.gravity = Gravity.BOTTOM;
        lp.x = 0;
        lp.y = 0;

        menuDialog.addContentView(menuView, lp);
        menuDialog.onWindowAttributesChanged(lp);
        menuDialog.setCanceledOnTouchOutside(true);
        menuDialog.setOnKeyListener(new OnKeyListener() {
            public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
                if (keyCode == KeyEvent.KEYCODE_MENU)
                    dialog.dismiss();
                return false;
            }
        });

        menuGrid = (GridView) menuView.findViewById(R.id.gridview);
        menuGrid.setAdapter(getMenuAdapter(menu_name_array, menu_image_array11));

        menuGrid.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                switch (i) {
                    case UP_ID:
                        controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_UP, (byte) 40);
                        break;

                    case DOWN_ID:
                        controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_DOWN, (byte) 40);
                        break;

                    case LEFT_ID:
                        controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_LEFT, (byte) 40);
                        break;

                    case RIGHT_ID:
                        controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_RIGHT, (byte) 40);
                        break;

                    case ZOOMIN_ID:

                        if (controller.isHDCam(videoType)) {
                            controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_HD_ZOOMIN, (byte) 40);
                        } else {
                            controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_ZOOMIN, (byte) 40);
                        }
                        break;

                    case ZOOMOUT_ID:

                        if (controller.isHDCam(videoType)) {
                            controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_HD_ZOOMOUT, (byte) 40);
                        } else {
                            controller.StepPTZControl(nodeID, channel, KaerController.PTZ_CMD_ZOOMOUT, (byte) 40);
                        }
                        break;

                    case LISTEN_ID:

                        if (isListen) {
                            controller.stopListen(nodeID, channel, isChild);
                            isTalk = false;
                            isListen = false;// 关闭监听的同时，停止对讲
                            SetGridViewBg(isTalk, isListen);

                        } else {
                            controller.startListen(nodeID, channel, isChild);
                            isListen = true;
                            SetGridViewBg(isTalk, isListen);

                        }
                        break;
                    case TALK_ID:

                        if (isTalk) {
                            controller.stopTalk(nodeID, channel, isChild);
                            isTalk = false;
                            SetGridViewBg(isTalk, isListen);

                        } else {
                            controller.startTalk(nodeID, channel, isChild);
                            isListen = true;// 开始对讲的同时开启监听
                            isTalk = true;
                            SetGridViewBg(isTalk, isListen);
                        }
                        break;
                }
            }
        });

    }

    @Override
    protected void onResume() {
        super.onResume();
        if (loginListener != null) {
            controller.registerLoginListener(loginListener);
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
            controller.stopListen(nodeID, channel, isChild);
            controller.stopRealTimeVideo();
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //menu.add(Menu.NONE, 0, 0, "菜单");
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onMenuOpened(int featureId, Menu menu) {
        if (menuDialog == null) {
            menuDialog = new AlertDialog.Builder(this).setView(menuView).show();
        } else {
            menuDialog.show();
        }
        return super.onMenuOpened(featureId, menu);
    }
}
